You're viewing an archived version of our docs. Check out our current documentation →
UI libraries / Vue InstantSearch / Widgets

ais-clear-refinements

Signature
<ais-clear-refinements
  // Optional parameters
  :excluded-attributes="string[]"
  :included-attributes="string[]"
  :transform-items="function"
  :class-names="object"
/>
Import
1
2
3
4
5
6
7
8
9
import { AisClearRefinements } from 'vue-instantsearch';
// Use 'vue-instantsearch/vue3/es' for Vue 3

export default {
  components: {
    AisClearRefinements
  },
  // ...
};

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-clear-refinements widget displays a button that lets users clears every currently applied refinement.

Examples

1
<ais-clear-refinements />

Props

excluded-attributes
type: string[]
default: ["query"]
Optional

The attributes to exclude from the refinements to clear. In the example below, the attribute brand is excluded from the refinements to clear.

This can’t be used with included-attributes.

1
2
3
<ais-clear-refinements
  :excluded-attributes="['brand']"
/>
included-attributes
type: string[]
default: []
Optional

The attributes to include in the refinements to clear (all by default). In the example below, only the categories attribute is included in the refinements to clear.

This can’t be used with excluded-attributes.

1
2
3
<ais-clear-refinements
  :included-attributes="['categories']"
/>
transform-items
type: function
default: items => items
Optional

Receives the items to clear, and is called before clearing them. Should return a new array with the same shape as the original array. Useful for filtering items.

In addition, the full results data is available, which includes all regular response parameters, as well as parameters from the helper (for example disjunctiveFacetsRefinements).

When using an array, take steps to avoid creating infinite loops. When you use an array as a prop, it causes the widget to re-register on every render, and this can sometimes cause these infinite loops.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
<template>
  <!-- ... -->
  <ais-current-refinements :transform-items="transformItems" />
</template>

<script>
  export default {
    methods: {
      transformItems(items) {
        return items.sort(item => item.attribute);
      },

      /* or, combined with results */
      transformItems(items, { results }) {
        return results.nbHits === 0
          ? items
          : items.filter(item => item !== 'brand');
      },
    },
  };
</script>
class-names
type: object
default: {}
Optional

The CSS classes you can override:

  • ais-ClearRefinements: the root container of the widget.
  • ais-ClearRefinements-button: the button of the widget.
  • ais-ClearRefinements-button--disabled: the disabled button of the widget.
1
2
3
4
5
6
7
<ais-clear-refinements
  :class-names="{
    'ais-ClearRefinements': 'MyCustomClearRefinements',
    'ais-ClearRefinements-button': 'MyCustomClearRefinementsButton',
    // ...
  }"
/>

Customize the UI

default

The slot to override the complete DOM output of the widget.

Note that when you implement this slot, none of the other slots will change the output, as the default slot surrounds them.

Scope

  • canRefine: boolean: are there any refinements?
  • refine: () => void: the function to clear all the refinements.
  • createURL: () => string: the function to return a link for the search without the refinements.
1
2
3
4
5
6
7
8
9
10
11
<ais-clear-refinements>
  <template v-slot="{ canRefine, refine, createURL }">
    <a
      :href="createURL()"
      @click.prevent="refine"
      v-if="canRefine"
    >
      Clear all refinements
    </a>
  </template>
</ais-clear-refinements>
resetLabel

The slot to override the DOM output for the label of the reset button.

1
2
3
<ais-clear-refinements>
  <template v-slot:resetLabel>Clear refinements</template>
</ais-clear-refinements>

HTML output

1
2
3
4
5
<div class="ais-ClearRefinements">
  <button class="ais-ClearRefinements-button">
    Clear refinements
  </button>
</div>

You're viewing an archived version of our docs. Check out our current documentation →
UI libraries / React InstantSearch / Widgets

<ClearRefinements>

This is the React InstantSearch v7 documentation. React InstantSearch v7 is the latest version of React InstantSearch and the stable version of React InstantSearch Hooks.

If you were using React InstantSearch v6, you can upgrade to v7.

If you were using React InstantSearch Hooks, you can still use the React InstantSearch v7 documentation, but you should check the upgrade guide for necessary changes.

If you want to keep using React InstantSearch v6, you can find the archived documentation.

Signature
<ClearRefinements
  // Optional props
  includedAttributes={string[]}
  excludedAttributes={string[]}
  transformItems={function}
  classNames={object}
  translations={object}
  ...props={ComponentProps<'div'>}
/>
Import
1
import { ClearRefinements } from 'react-instantsearch';

About this widget

<ClearRefinements> is a widget that resets the active refinements of the search.

You can control which attributes are cleared with the props.

You can also create your own UI with useClearRefinements().

Examples

1
2
3
4
5
6
7
8
9
10
11
12
13
import React from 'react';
import { liteClient as algoliasearch } from 'algoliasearch/lite';
import { InstantSearch, ClearRefinements } from 'react-instantsearch';

const searchClient = algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey');

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <ClearRefinements />
    </InstantSearch>
  );
}

Props

includedAttributes
type: string[]
default: []

The attributes to include in the refinements to clear (all by default). Can’t be used with excludedAttributes. In the example below, only the categories attribute is included in the refinements to clear.

1
<ClearRefinements includedAttributes={['categories']} />
excludedAttributes
type: string[]
default: ["query"]

The attributes to exclude from the refinements to clear. Can’t be used with includedAttributes. In the example below, the attribute brand is excluded from the refinements to clear.

1
<CurrentRefinements excludedAttributes={['brand']} />
transformItems
type: (items: object[], metadata: { results: SearchResults }) => object[]
Optional

Function which receives the items to clear, which is called before clearing them. Should return a new array with the same shape as the original array. Useful for filtering items.

In addition, the full results data is available, which includes all regular response parameters, as well as parameters from the helper (for example disjunctiveFacetsRefinements).

1
2
3
4
5
6
7
8
9
10
11
12
const transformItems = (items) => {
  return items.filter((item) => item.attribute !== 'brand');
};

function Search() {
  return (
    <ClearRefinements
      // ...
      transformItems={transformItems}
    />
  );
}
classNames
type: Partial<ClearRefinementsClassNames>
Optional

The CSS classes you can override and pass to the widget’s elements. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.

  • root: The root element of the widget.
  • button: The button element.
  • disabledButton: The button element when there are no refinements to clear.
1
2
3
4
5
6
<ClearRefinements
  classNames={{
    root: 'MyCustomClearRefinements',
    button: 'MyCustomClearRefinementsButton MyCustomClearRefinementsButton--subclass',
  }}
/>
translations
type: Partial<ClearRefinementsTranslations>
Optional

A dictionary of translations to customize the UI text and support internationalization.

  • resetButtonText: The text for the reset button.
1
2
3
4
5
<ClearRefinements
  translations={{
    resetButtonText: 'Clear all',
  }}
/>
...props
type: React.ComponentProps<'div'>
Optional

Any <div> prop to forward to the root element of the widget.

1
<ClearRefinements className="MyCustomClearRefinements" title="My custom title" />

Hook

React InstantSearch let you create your own UI for the <ClearRefinements> widget with useClearRefinements(). Hooks provide APIs to access the widget state and interact with InstantSearch.

The useClearRefinements() Hook accepts parameters and returns APIs. It must be used inside the <InstantSearch> component.

Usage

First, create your React component:

import { useClearRefinements } from 'react-instantsearch';

function CustomClearRefinements(props) {
  const { refine, canRefine, createURL } = useClearRefinements(props);

  return <>{/* Your JSX */}</>;
}

Then, render the widget:

<CustomClearRefinements {...props} />

Parameters

Hooks accept parameters. You can pass them manually, or forward the props from your custom component.

When you provide a function to Hooks, make sure to pass a stable reference to avoid rendering endlessly (for example, with useCallback()). Objects and arrays are memoized; you don’t need to stabilize them.

includedAttributes
type: string[]
default: []

The attributes to include in the refinements to clear (all by default). Can’t be used with excludedAttributes. In the example below, only the categories attribute is included in the refinements to clear.

1
2
3
const clearRefinementsApi = useClearRefinements({
  includedAttributes: ['categories'],
});
excludedAttributes
type: string[]
default: ["query"]

The attributes to exclude from the refinements to clear. Can’t be used with includedAttributes. In the example below, the attribute brand is excluded from the refinements to clear.

1
2
3
const clearRefinementsApi = useClearRefinements({
  excludedAttributes: ['brand'],
});
transformItems
type: (items: string[], metadata: { results: SearchResults }) => string[]
Optional

Function which receives the items to clear, which is called before clearing them. Should return a new array with the same shape as the original array. Useful for filtering items.

In addition, the full results data is available, which includes all regular response parameters, as well as parameters from the helper (for example disjunctiveFacetsRefinements).

1
2
3
4
5
6
7
8
9
10
11
12
const transformItems = (items) => {
  return items.filter((item) => item !== 'brand');
};

function ClearRefinements() {
  const clearRefinementsApi = useClearRefinements({
    // ...
    transformItems,
  });

  return <>{/* Your JSX */}</>;
}

APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.

refine
type: () => void

Clears all the currently refined values and triggers a new search.

canRefine
type: boolean

Indicates if search state can be refined.

createURL
type: () => string

Generates a URL of the next state.

Example

1
2
3
4
5
6
7
8
9
10
11
12
import React from 'react';
import { useClearRefinements } from 'react-instantsearch';

function CustomClearRefinements(props) {
  const { canRefine, refine } = useClearRefinements(props);

  return (
    <button disabled={!canRefine} onClick={refine}>
      Clear refinements
    </button>
  );
}